<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2//EN">

<HTML>

<HEAD>
<TITLE>Cours/TD - 4</TITLE>
<link REL="StyleSheet" TYPE="text/css" HREF="Costyle.css">

</HEAD>
<BODY BACKGROUND="../icons/brick.jpg">

<CENTER><H1>Cours/TD - (4)</H1>
</CENTER>
<P>
<p>


<TABLE width=100%>
 <TR><TD align=left><A HREF="comres3.html"><IMG SRC="../icons/gb_larr.gif" border=0 align=absmiddle></A></TD>
<TD align=right><A HREF="comres5.html"><IMG SRC="../icons/gb_rarr.gif" border=0 align=absmiddle></A></TD>
</TR>
</TABLE>
<p>
<FONT COLOR=#0000FF FACE="Helvetica,Arial" point-size=14pt>

<H3><FONT COLOR=#f00000>02.11.99</FONT></H3>
<p>


<H2>Cours</H2>


<H3>Le code et son exécution</H3>

À présent nous avons les ingrédients indispensables pour la construction d'une machine virtuelle à pile complète (ou presque) - semblable à celle du PostScript - qui exécute des programmes comportant les expressions arithmétiques, affectations des variables globales, conditionnelles, définitions des fonctions utilisateur, récursivité et boucles. La machine doit être de bas niveau, et "plate", par exemple nous n'avons pas le droit de définir la récursivité par une sémantique récursive de la machine elle-même. Ceci n'est pas une exigence gratuite au nom du "purisme scientifique"!
La machine doit être efficace, elle ne doit pas prendre dynamiquement des décisions redondantes, et effectuer le décodage qui peut être fait par le compilateur. On va donc "massacrer" le code postfixe naïf, on remplacera les constructions plus proches du programme-source par les items de bas niveau. <p>

Si l'instruction <TT>x=3*x+2/x</TT> ou sa version postfixe <TT>[x 3 x * 2 x / + =]</TT> est laissée sans optimisation, ce que <A HREF="comres3.html#codstruct">nous avons fait précédemment</A>, notre système basé sur un langage typé doit quand même prévoir un type commun pour tous ces objets. Ensuite, la machine doit prendre quelques décisions, par exemple : si l'item est une valeur, alors empiler-le, sinon, si c'est un opérateur, alors exécuter le code qui lui est attribué, etc. <EM>Mais le générateur de code aurait pu faire cette distinction avant l'exécution.</EM> <P>

Donc, même si nous pouvions - comme en PostScript - baliser tous les éléments de la liste qui représente le code, p. ex.
<PRE style="color: #D00000">
type Code = [CodeItem]
data CodeItem = Var Symbol | Oper Symbol 
               | I Integer | Co Code | ...
</PRE>
etc., comme nous avons suggéré pour les <I>Valeurs</I>, ceci ne serait pas avantageux. De préférence le code doit être exécutable plus directement. 
<UL type="square">
<LI> Certains symboles sont naturellement des variables. Le code ne doit <EM>jamais</EM> référencer les symboles, mais l'emplacement qui contient la valeur correspondante, ou l'association. Ceci a déjà été discuté.
<P>


<LI> Parfois on peut directement remplacer le symbole par sa valeur (le décodage  d'une chaîne numérique se fait déjà pendant l'analyse lexicale). Il y a des constantes symboliques (p. ex. <TT>#define</TT> en C), mais surtout : les opérations primitives, les fonctions prédéfinies etc. sont des symboles constants qui doivent être remplacés par leurs valeurs, à moins qu'on ne puisse changer cela pendant l'exécution. <p>

Ce commentaire est important. Cette flexibilité fait que le programme Postscript , p. ex. le code de notre <TT>cube</TT> : <TT>{dup dup mul mul}</TT> contient justement les symboles, décodés pendant l'exécution. Mais la machine PostScript (et ses concepteurs) ne sont pas si négligeants. Si le programmeur <I>sait</I>, qu'aucun changement de signification n'aura lieu, avant de compléter la définition par <TT>def</TT>, il force l'exécution de la commande <TT>bind</TT>. Cette commande attend sur la pile un objet composite, une procédure utilisateur, et remplace à son intérieur tous symboles par les valeurs correspondantes, par l'adresse de la procédure <TT>dup</TT>, <TT>mul</TT>, etc.
<P>


<LI> Notre machine construite à l'aide d'un langage de haut niveau n'opère pas avec/sur des "adresses", ou "pointeurs" (pardonnez les gros mots). Nous allons placer dans le code <EM>des objets procéduraux</EM> directement. <P>

<SPAN class=ib>Directement?</SPAN> Et les données explicites dans le code? Aucun problème, un langage fonctionnel permet aisément de créer des fermetures (objets fonctionnels qui "attrapent" les paramètres). On remplace une constante par une procédure qui l'empile (qui sera une application partielle). Si on oublie les balises des données, et on opère sur un seul type de données, p. ex. numérique, il faudra prévoir un certain nombre d'objets primitifs, comme
<PRE>
dup l@(x:p) = x:l
mul (x:y:p) = (x*y):p

ldc c p = c:p
</PRE>
où <TT>ldc</TT> (<I>load constant</I>) empile son premier paramètre. Toutes ces fonctions prennent la pile de données comme paramètre, et retournent la pile modifiée. Au lieu d'avoir le code <TT>{... dup 2 mul ...}</TT> nous aurons <TT>[... dup,(ldc 2), mul, ...]</TT>. Donc, le type CodeItem se réduit à :
<PRE>
type CodeItem = Pile -&gt; Pile   --<I> où</I>
type Pile = [Value]
</PRE>

Si les opérateurs primitifs décodent les variables dynamiques, peuvent effectuer les affectations, etc., il faut qu'ils prennent également l'environnement en argument. Nous ferons ceci un peu plus tard, à présent il faut régler une autre difficulté.
<P>
</UL><p>

<H3>Procédures utilisateur, et récursivité de la machine virtuelle </H3>
<p>

Nous pouvons maintenant essayer de définir la machine virtuelle à pile comme une fonction
<PRE style="color: #D00000">
exec :: (Code, Pile) -&gt; (Code, Pile)

exec ((instr:reste),p) = 
  let np=instr p in exec (reste,np)
</PRE>
où il y a beaucoup de choses qui manquent !
<UL type="square">
<LI> L'environnement n'est pas géré. Ma&ntilde;ana, muchachos y ballerinas ...
<LI> On ne sait pas comment la machine s'arrête. Mais doit-elle? Le microprocesseur
  ne s'arrête jamais (s'il marche du tout), dans le pire des cas il effectue une boucle "morte".
<LI> Que fait-on si la liste-code est vide? On s'arrête?...
<LI> On ne sait pas encore comment exécuter une procédure utilisateur.
</UL>

Donc, la définition de notre procédure <TT>cube</TT> (et le décodage de ce symbole) est la liste <TT>[dup, dup, mul, mul]</TT>, et cette liste doit figurer dans le code, probablement attachée comme paramètre d'une instruction. Mais pourquoi ne pas utiliser tout simplement la récursivité? Définir la puissance 5 d'un nombre comme
<PRE>
[dup, dup, (execc cube), mul, mul] where
  execc code pile = exec (code,pile)
</PRE>
Il y a quelques raisons pour ne pas laisser l'interprète comme ça, même si la solution est élégante et lisible. On ne doit pas exploiter la récursivité dans la définition de la machine virtuelle, car ceci engage la pile système <I>de la machine elle-même</I> de façon non-triviale. Ceci est inefficace, rend le déboguage et la récupération du contrôle après une erreur assez difficile. On ne pourra pas optimiser les récursions terminales. Bref, il faut chercher un autre moyen d'implanter cela.<p>

D'abors, introduisons la convention suivante : <B>Une liste-code n'est jamais vide</B> Ceci rendra possible une optimisation importante - l'allocation du code dans un tableau, et non pas dans une liste. Une procédure est un fragment de code, qui peut être suivi par d'autres fragments. Chaque fragment se termine par une <EM>instrution de retour</EM> explicite, disons <TT>ret</TT>. Cette procédure n'a pas besoin de la pile des données, mais que fait-elle?<p>

Le retour (à la fin d'une procédure, ou à son intérieur) ne semble pas être un opérateur normal, car il doit forcer la machine à quitter (cette instance de) la boucle <TT>exec</TT>.
<p>

Le code complet sera présenté prochaînement, ici nous donnons l'idée générale.
<UL type="disc">
<LI> La machine prendra encore un paramètre, la <EM>pile des retours</EM>.
<LI> Le code qui est en train d'exécution est toujours adressé indirectement, par le sommet de cette pile.
<LI> Les opérateurs peuvent accéder aussi à cette pile, en particulier ...
<LI> L'opérateur <TT>ret</TT> en dépile le sommet.
<LI> Nous pouvons ainsi introduire un autre opérateur de contrôle : <TT>stop</TT> qui
écrase complètement la pile des retours, permettant de quitter toute la chaîne d'imbrications récursives en cas d'erreur.
<LI> L'exécution du code utilisateur (qui peut être récursif) empile l'adresse du retour
récursif, et c'est tout. La machine reste itérative.
</UL>

La machine virtuelle devient ainsi beaucoup plus simple, et en même temps il est plus facile de gérer les exceptions.

<!-- ********************************************************* --><p>
<CENTER><IMG SRC="../icons/limarro.gif" WIDTH="576" HEIGHT="9" ALT="">
</CENTER>
<p>

<p>
<H2>TD</H2>
<p>
<B>Alors, personne n'a voulu gagner une bouteille de champagne en proposant l'optimisation du code de la fonction sinus, qui utilise la formule de triplication de l'angle? Tant pis, ceci est votre perte. </B><P>



<H3>Files fonctionnelles</H3>
<p>
Les listes sont des bonnes structures de données pour représenter les piles. Pour empiler un objet sur la pile, ou le dépiler, en retournant cet objet et la pile restante, nous pouvons écrire
<PRE>
empiler x pile = x:pile
depiler (x:pq) = (x,pq)
</PRE>
et on voit clairement, qu'une introduction de telles fonctions est redondante : empiler n'est rien d'autre que <TT>(:)</TT>, et le dépilement est une transformation de pattern normalement inutile. Ces opérations sont efficaces, chaque manipulation prend un temps constant. <p>

Avec les files (<I>queues</I>, structures <B>FIFO</B> (<I>First-in - first-out</I>)) la situation est plus délicate. Si on utilise une liste, une extrémité sert d'entrée, et l'autre de sortie. Si nous décidons d'avoir la même définition de <TT>defiler</TT> que <TT>dépiler</TT>, alors l'attachement d'un nouvel élément à la fin peut utiliser la fonction <TT>enfiler x file = file ++ [x]</TT>, ce qui récopie le file entière. la complexité de cette procédure est linéaire en longueur de la file.<p>

Vice-versa, si on attache le nouvel élément au début, la procédure de défilement sera assez compliquée, par exemple
<PRE>
defiler [x] (x,[])
defiler (y:f) = (x,(y:p)) where (x,p)=defiler f
</PRE>
Ceci est une procédure récursive "en profondeur", qui encombre la pile système avec N objets (où N est la taille moyenne de la file). Une solution alternative - proposé par un de vous - était de inverser la liste, récupérer le premier élément, et inverser le reste. Ici, si la procédure d'inversion est raisonnable, il n'y a pas d'encombrement de la pile, mais la création d'une liste intermédiaire sur le tas-système. Ceci n'est pas idéal non plus, chaque fois une manipulation - soit l'insertion, soit la suppression d'un élément, coûte N unités. <p>

On peut faire mieux, si au lieu d'utiliser une liste, on représente la file par une paire de listes <TT>(p,q)</TT>, où <TT>p</TT> est la liste d'entrée, directe, à laquelle on attache les objets, et <TT>q</TT> est une liste "inversée", permettant de supprimer les éléments sans parcourir la liste. Voici les procédures de manipulation :
<PRE>
enfiler x (p,q) = (x:p,q)

defiler (p, (x:q)) = (x, (p,q))
defiler (p, []) = defiler ([], inverse p)
</PRE>
Alors, si après un certain nombre d'insertions et de suppressions la taille moyenne de la file (la somme des longueurs de p et q) est d'ordre N, "normalement" l'insertion et la suppression sont des opérations rapides. Une fois sur N (en moyenne), la liste q devient vide, et il faudre inverser la liste p. Ceci apporte la complexité d'order N, mais une telle opération est rare. La complexité <I>amortie</I> : le coût mouen d'une manipulation reste constant, et ne grandit pas
avec la longueur moyenne de la file.<p>

Le but de cet exercice était de prouver que si on connaît quelques "trucs" (plutôt : <SPAN class=ib>si on lit la littérature consacrée à la programmation fonctionnelle</SPAN>), on peut améliorer l'efficacité de quelques algorithmes de gestion de données, sans recours aux techniques destructrices, impératives. Ces dernières seront toujours utilisées quand l'objectif principal du programmeur est la vitesse d'exécution, mais parfois d'autres crières prédominent.

<!-- ********************************************************* --><p>
<CENTER><IMG SRC="../icons/limarro.gif" WIDTH="576" HEIGHT="9" ALT="">
</CENTER>
<p>

<H3>Encore un exercice sur le non-déterminisme</H3>
<P>

Personne n'a oublié encore - je l'espère - la définition de la concaténation en Haskell. Cette définition:
<PRE>
(++) [] l = l
(++) (x:q) l = x:r where r=q++l
</PRE>
peut être traduite en Prolog de manière complètement mécanique, il suffit de changer un peu la syntaxe des listes, et ne pas oublier qu'en Prolog on définit les prédicats, et non pas les fonctions. Un des arguments du prédicat sera le paramètre de sortie, le résultat. Voici cette définition :
<PRE>
append([],L,L).
append([X|Q],L,[X|R]) :- append(Q,L,R).
</PRE>
et si on lance la requête : <TT>append([a,b],[c],L)</TT>, le système répond : <TT>L=[a,b,c]</TT>. Rien à ajouter.<p>

Cependant, Prolog "ne sait pas" quels sont les paramètres d'entrée, et de sortie. Si une requête logique, l'appel à un prédicat, contient quelques arguments connus, instanciés, alors ils seront traités comme les arguments d'entrée. Si, par contre, un (ou plusieurs) des arguments sont des variables non-instanciées, Prolog les considère comme des paramètres de sortie, et par l'unification tentera de leur attribuer une valeur. Il n'y a rien de mauvais donc dans cet appel pervers : <TT>append(A,B,[a,b,c]).</TT> <p>

La réponse du système est immédiate : la première clause dit :
<PRE>
A=[]
B=[a,b,c]
</PRE>
car <TT>L</TT> est directement unifiable avec la valeur passée dans l'appel  de <TT>append</TT>. en conséquence, B et L sont identifiés, et A devient vide. Rien à ajouter? Cette fois si. Si cette requête fait partie d'un module dont l'exécution échoue, ou si l'utilisateur provoque l'échec manuellement en tapant ";" (lisez ,ca: <I>ou alors?...</I>) après l'affichage de A et B, le prédicat <TT>append</TT> re,coit une deuxième chance, et lance la deuxième clause. L'unificateur identifie : <TT>[X|R] = [a,b,c]</TT>, et donc <TT>X=a, R=[b,c]</TT>. Ensuite l'appel récursif relance la première clause (pourquoi pas?), ce qui fixe <TT>Q=[], L=[b,c]</TT>. La réponse finale est donc
<PRE>
A=[a]
B=[b,c]
</PRE>
L'échec de cet appel engendrera <TT>A=[a,b], B=[c]</TT>, ensuite <TT>A=[a,b,c], B=[]</TT>, et finalement le système répond : <B>no</B>. Plus de réponses.<p>

La séparation d'une suite en deux (ou plusieurs) segments est la fondation du parsing non-déterministe. On teste ensuite si les segments remplissent quelques conditions ultérieures. Un échec éventuel cherche une autre partition. Essayons donc de construire une telle fonction non-déterministe en Haskell. Il es évident que la concaténation "à l'envers" ne marchera pas. Mais nous pouvons commencer par cela et ensuite lancer la moulinette de traduction, le "lifting" non-déterministe (après avoir choisi un nouveau nom) :
<PRE>
split l = ([],l)
split (x:r) =  ((x:q),l)  where (q,l)=split r
</PRE>
La "moulinette" consiste à mettre une réponse concrète dans une liste (la première clause), passer par <TT>map</TT> toute manipulation fonctionnelle d'un appel récursif, et concaténer les alternatives. Voici la solution finale :
<PRE>
split l@(x:r) = ([],l) : map (\(q,l) -&gt; ((x:q),l)) 
                         (split r)
split [] = [([],[])]
</PRE>
Nous avons eu une courte discussion concernant la clause vide. Est-ce souhaitable de pouvoir scinder une liste vide en deux listes vides? Un de vous a proposé la liste vide comme réponse, c'est-à-dire l'échec. J'ai hésité ...<p>
<SPAN class=ib>La réponse ci-dessus est officielle.</SPAN> Si on rejète cette solution, le dernier élément de la scission de <TT>[1,2,3,4]</TT> sera <TT>([1,2,3],[4])</TT>, et jamais <TT>([1,2,3,4],[])</TT>.
<p>


<!-- ********************************************************* --><p>
<CENTER><IMG SRC="../icons/limarro.gif" WIDTH="576" HEIGHT="9" ALT="">
</CENTER>
<p>



<H3>Un parseur non-déterministe en Prolog</H3>
<P>

La construction d'un parseur non-déterministe, surtout dans un langage où le non- déterminisme est assuré par la sémantique du langage même, est très simple et élégant. Les optimisations "professionnelles" sont indispensables pour un vrai compilateur, et un tel programme doit être déterministe, mais ceci ne nous préoccupe pas ici. Il faut simplement accepter le fait qu'un parseur non-déterministe peut se lancer sur une branche d'analyse, qui plus tard sera condamnée à l'échec, et il faudra répéter le travail. <p>

Commençons la construction par une définition syntaxique du langage (très simplifié) des expressions arithmétiques. Une expression peut contenir les symboles (chiffres ou lettres) qui représentent les données, la multiplication, l'addition, et les parenthèses. Voici la grammaire correspondante en BNF. Elle tient compte de la précédence des opérateurs, et de leur associativité:
<a name="algram"></a>
<PRE class=he>
expr ::= terme | expr + terme
terme ::= facteur | terme * facteur
facteur ::= atome | ( expr )
</PRE><P>

c'est-à-dire : une expression peut être un terme ou une somme de termes. L'associativité de l'addition est gauche : a+b+c = (a+b)+c. (À cause de la commutativité, l'addition est associative tout court, mais avec la soustraction il faut être plus vigilant). <p>
Un terme peut être le produit de quelques facteurs, ou un seul, et un facteur est soit une expression parenthésée, soit un atome. <B>La grammaire et l'analyseur se terminent ici</B>. La notion d'atôme appartient à une couche plus basse, de l'analyse : la couche lexicale. Pour l'instant nous pouvons considérer qu'un atôme est un caractère alphanumérique.<p>

L'analyse proprement dite ne s'occupe pas du "résultat" sous forme arborescente ou autre. Elle doit simplement répondre à la question si la phrase analysée appartient au langage ou non. Mais un analyseur syntaxique "répond positivement" plutôt en construisant la représentation interne de la phrase que par un simple oui/non. En Prolog la construction de nouvelles structures de données est une opération très facile. Si l'argument d'un prédicat à la forme d'un "appel fonctionnel", par exemple <TT>add(X,y)</TT> où <TT>add</TT> n'a aucune signification primitive, alors cette forme est considéré comme un <I>record</I> à deux champs. En fait - à trois champs. Le premier est le symbole <TT>add</TT> qui joue le rôle de balise et identifie le "type de données". Les autres sont occupés (ici) par <TT>X</TT> et <TT>y</TT>. Une structure composite en Prolog s'appelle <I>terme</I>, mais nous éviterons d'utiliser ce mot pendant la construction d'un parseur arithmétique, où ce mot dénote une variable syntaxique...<p>

Le squelette du parseur est très simple. Si l'expression contient quelque par l'opérateur "+", ceci est une somme de termes, sinon c'est un terme. Bien sûr, on peut trouver l'addition entre parenthèses, mais un telle coupure de l'expression est illégale. Illégale, mais ce fait sera reconnu plus tard, ceci est le prix du non-déterminisme. Voici le parseur en Prolog. Il construit des structures arborescentes, mais il ignore les erreurs (Toute erreur provoque un échéc sans autres diagnostics). Les feuilles sont des atômes sans aucun "emballage". Le prédicat primaire est l'<TT>expr(Liste,Arbre)</TT>, où <TT>Liste</TT>  représente le flot d'entrée, p. ex "2*x+(3+2*x)*2", et <TT>Arbre</TT> - la structure correspondante, dans ce cas : <TT>add(mul(2,x),mul(add(3,mul(2,x)),2))</TT>
<PRE>
expr(L,add(X,Y)):-append(L1,['+'|L2],L),expr(L1,X),terme(L2,Y).
expr(L,X):-terme(L,X).

terme(L,add(X,Y)):-append(L1,['+'|L2],L),terme(L1,X),facteur(L2,Y).
terme(L,X):-facteur(L,X).

facteur(['('|L],R):-append(L1,[')'],L),expr(L1,R).
facteur([X],X):-atomeLegal(X).
</PRE>

Le coût global d'une telle stratégie de parsing n'est pas principalement le résultat de plusieurs tentatives de <TT>append</TT> (même si c'est très important), mais le découpage du flot d'entrée entier en morceaux, où chaque morceau représente <b>une</b> expression. Ce découpage produit plusieurs listes intermédiaires, et il peut être également dans quelques contextes sumis au non-déterminisme. Peut-on travailler directement avec une liste looongue, qui contient le programme complet, et où le parseur doit trouver l'expression en début, et laisser le reste de la liste pour son
successeur?<p>

Pour l'approche fonctionnelle à la construction des parseurs, où il n'y a pas d'"instructions de lecture du buffer", mais la consommation d'une suite linéaire d'objets (lettres, mots, graphes, ...), la réponse à cette question est essentielle. Essayons de <EM>voir conceptuellement</EM> la liste d'entrée <TT>L</TT> (ou ses fragments) comme une paire <TT>LT, LR</TT>, où <TT>LT</TT> représente le flot entier, et <TT>LR</TT> - la liste restante après la terminaison du parsing. Ainsi, la dernière clause du parseur devient
<PRE>
facteur([X|LR],LR,X):-atomeLegal(X).
</PRE>
Simple, non? Cependant, les clauses récursives sont plus délicates, il nous faudra définir un prédicat <TT>appendd(LT1,LR1,LT2,LR2,LT,LR)</TT> qui opère sur de telles paires, et effectue l'équivalent de concaténation (transformée en découpage non-déterministe). Une telle manipulation s'appelle dans le domaine des langages logiques la gestion des <EM>listes différentielles</EM>, et est utilisée fréquemment dans la programmation des parseurs et autres analyseurs en Prolog dans le style DCG (<I>Definite Clause Grammars</I>. Pour nous le concept de "liste différentielle" est purement abstrait, c'est le fragment initial après la "soustraction" conceptuelle de la queue d'une liste de longueur <I>arbitraire</I>. Regardez le dessin ci-dessous, qui montre l'idée de découpage conceptuel d'un flot de longueur quelconque :
<P>
<CENTER><IMG SRC="lisdif.gif" WIDTH="546" HEIGHT="252" ALT=""></CENTER><P>

On voit immédiatemment que
<PRE class=he>
LT1 = LT
LR1 = LT2
LR2 = LR
</PRE>
ce qui réduit le prédicat <TT>appendd</TT> en une <EM>forme syntaxique pure</EM>, sans aucun "corps exécutable"
<PRE>
appendd(LT,LT2,LT2,LR,LT,LR).
</PRE>
Non, ceci n'a rien d'"éxotique". En Haskell on n'utilise <B>jamais</B> les fonctions CAR ou CDR de Lisp, car nous pouvons toujours déstructurer une liste à l'aide du pattern (x:q). <TT>appendd</TT> devient une sorte de pattern, ce qui permet faire automatiquement la simplification suivante :
<PRE>
facteur(['('|LT],LR,R):-appendd(L1,L1R,[')'|LQ],LQ,LT,LR),
                        expr(L1T,L1R,R).
===&gt;

facteur(['('|LT],[')'|LR],R) :- expr(LT,LR,R).
</PRE>
et si vous avez des doutes "exécutez manuellement" le prédicat <TT>appendd</TT>. Les autres clauses subissent les transformations suivantes :
<PRE>
expr(LT,LR,add(X,Y)) :- expr(LT,['+'|LQ],X),
                        terme(LQ,LR,Y).
expr(LT,LR,X) :- terme(LT,LR,X).

terme(LT,LR,mul(X,Y)) :- terme(LT,['*'|LQ],X),
                         facteur(LQ,LR,Y).
terme(LT,LR,X) :- facteur(LT,LQ,X).
</PRE>
et la correspondance entre la grammaire et le parseur est presque idéale. Nous allons utiliser une technique semblable dans un contexte fonctionnel classique, "orthodoxe", sans non-déterminisme primitif, mais la philosophie reste la même. Il y a un petit problème, qui sera discuté plus tard. L'associativité gauche des opérateurs implique la <EM>récursivité à gauche</EM> des prédicats. Ceci, dans le contexte où l'argument primaire, le flot d'entrée entier reste le même (<TT>L</TT>) risque de planter le parseur. Il faudra effectuer la normalisation de Greibach (transformation des productions récursivas à gauche en récursives à droite) d'abord. Vous devez connaître déjà l'idée de cette transformation, et au moins les règles formelles de son application.




<TABLE width=100%>
 <TR><TD align=left><A HREF="comres3.html"><IMG SRC="../icons/gb_larr.gif" border=0 align=absmiddle></A></TD>
<TD align=right><A HREF="comres5.html"><IMG SRC="../icons/gb_rarr.gif" border=0 align=absmiddle></A></TD>
</TR>
</TABLE>
<p>


</FONT>
</BODY>

</HTML>
